using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Media;

namespace NoJavaLibrary.Game
{
    /// <summary>
    /// WAVEt@CvC[
    /// </summary>
    public class SoundFilePlayer
    {
        delegate void FileChangeEventHandler(string path);

        class SoundStream : FileStream
        {
            #region ϐ
            string path;
            long ptr;
            int headerSize;
            SoundFilePlayer sfPlayer;
            #endregion

            public SoundStream(string path, SoundFilePlayer sfPlayer)
                : base(path, FileMode.Open)
            {
                this.path = path;
                ptr = 0;
                this.sfPlayer = sfPlayer;
                RegistersfPlayerEventHandler();
            }
            #region ֐
            /// <summary>
            /// wb_[̃TCYԂ
            /// </summary>
            /// <returns></returns>
            int GetHeaderSize()
            {
#warning `ł܂߂ɏI
                return 44;
            }

            public override int Read(byte[] array, int offset, int count)
            {
                headerSize = GetHeaderSize();
                if (ptr > headerSize)
                {
                    base.Read(array, 0, headerSize);
                    base.Read(array, (int)ptr, (int)(count - ptr));
                    base.Read(array, (int)headerSize, (int)(ptr - headerSize));
                }
                else
                {
                    base.Read( array, offset, count);
                }
                return 0;
            }

            #region Cxgnho^
            /// <summary>
            /// senderɑ΂ăCxgnho^
            /// </summary>
            void RegistersfPlayerEventHandler()
            {
                sfPlayer.PlayerStop += new EventHandler(sfPlayer_PlayerStop);
                sfPlayer.PlayerSuspend += new EventHandler(sfPlayer_PlayerSuspend);
                sfPlayer.Discreating += new DiscreatingEventHandler(sfPlayer_Discreating);
            }

            /// <summary>
            /// senderɑ΂ẴCxgnh폜
            /// </summary>
            void DisregistersfPlayerEventHandler()
            {
                sfPlayer.PlayerStop -= new EventHandler(sfPlayer_PlayerStop);
                sfPlayer.PlayerSuspend -= new EventHandler(sfPlayer_PlayerSuspend);
                sfPlayer.Discreating -= new DiscreatingEventHandler(sfPlayer_Discreating);
            }
            #endregion

            protected override void Dispose(bool disposing)
            {
                base.Dispose(disposing);
            }
            #endregion

            #region Cxgnh
            void sfPlayer_PlayerStop(object sender, EventArgs e)
            {
                this.ptr = 0;
            }

            void sfPlayer_PlayerSuspend(object sender, EventArgs e)
            {
                this.ptr = base.Position;
            }

            void sfPlayer_Discreating()
            {
                DisregistersfPlayerEventHandler();
            }
            #endregion
        }

        #region ϐ
        SoundPlayer player;
        SoundStream stream;
        string FilePath { set {
            lock(player)
            player.Stop();
            if (stream != null)
            {
                stream.Dispose();
            }
            stream = new SoundStream(value, this);
        } }
        #endregion

        #region Cxg
        /// <summary>
        /// ꎞ~Ƃ
        /// </summary>
        event EventHandler PlayerSuspend;
        /// <summary>
        /// ~Ƃ
        /// </summary>
        event EventHandler PlayerStop;
        /// <summary>
        /// Đt@CςƂ
        /// </summary>
        event FileChangeEventHandler FileChange;
        /// <summary>
        /// łƂ
        /// </summary>
        event DiscreatingEventHandler Discreating;
        #endregion
        public SoundFilePlayer() : this("")
        {
        }

        public SoundFilePlayer(string soundLocation)
        {
            stream = new SoundStream(soundLocation, this);
            player = new SoundPlayer(stream);
        }

        #region ֐
        /// <summary>
        /// Đ
        /// </summary>
        public void Play()
        {
            player.Play();
        }

        /// <summary>
        /// ~
        /// </summary>
        public void Stop()
        {
            player.Stop();
            PlayerStop(this, new EventArgs());
        }

        /// <summary>
        /// ꎞ~
        /// </summary>
        public void Suspend()
        {
            player.Stop();
            PlayerSuspend(this, new EventArgs());
        }

        void Discreate()
        {
            player.Stop();

            Discreating();

            player.Dispose();
            stream.Dispose();
        }
        #endregion
    }
}
